
Ruby - Bug #19902

strftimeの返り値のascii_only?が間違っていることがある

09/26/2023 12:33 AM - znz (Kazuhiro NISHIYAMA)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 3.2.2 (2023-03-30 revision

e51014f9c0) [aarch64-linux]

Backport: 3.0: UNKNOWN, 3.1: UNKNOWN, 3.2:

DONE

Description

ruby-jp slack で tompng さんの調査によると以下のように Regexp.esacpe が変になる原因は t.ascii_only? #=> true になっていることでした。

irb(main):053> t = Time.now.strftime(u='あ')

=> "あ"

irb(main):054> t==u

=> true

irb(main):055> t.encoding==u.encoding

=> true

irb(main):056> Regexp.escape(t)

=> "\xE3\x81\x82"

irb(main):057> Regexp.escape(u)

=> "あ"

 git bisect で make miniruby && ./miniruby -ve "p Time.now.strftime('%Y年').ascii_only?" をしつつ調べてみると、

https://github.com/ruby/ruby/commit/f34280ec6b684eeb21ef3336c7002e1a83dcfd2c から true になってしまっているようです。

Associated revisions

Revision 6b66b5fdedb2c9a9ee48e290d57ca7f8d55e01a2 - 09/26/2023 06:35 AM - nobu (Nobuyoshi Nakada)

[Bug #19902] Update the coderange regarding the changed region

Revision 6b66b5fdedb2c9a9ee48e290d57ca7f8d55e01a2 - 09/26/2023 06:35 AM - nobu (Nobuyoshi Nakada)

[Bug #19902] Update the coderange regarding the changed region

Revision 6b66b5fd - 09/26/2023 06:35 AM - nobu (Nobuyoshi Nakada)

[Bug #19902] Update the coderange regarding the changed region

Revision ddbab4f837460f070942e8127de9a9f1b9868fff - 09/30/2023 04:51 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 6b66b5fdedb2c9a9ee48e290d57ca7f8d55e01a2: [Backport #19902]

    [Bug #19902] Update the coderange regarding the changed region

    ---

     ext/-test-/string/set_len.c       | 10 ++++++++++

     string.c                          | 27 +++++++++++++++++++++++++++

     test/-ext-/string/test_set_len.rb | 29 +++++++++++++++++++++++++++++

     3 files changed, 66 insertions(+)

Revision ddbab4f837460f070942e8127de9a9f1b9868fff - 09/30/2023 04:51 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 6b66b5fdedb2c9a9ee48e290d57ca7f8d55e01a2: [Backport #19902]

    [Bug #19902] Update the coderange regarding the changed region

    ---

     ext/-test-/string/set_len.c       | 10 ++++++++++

     string.c                          | 27 +++++++++++++++++++++++++++

     test/-ext-/string/test_set_len.rb | 29 +++++++++++++++++++++++++++++

     3 files changed, 66 insertions(+)

Revision ddbab4f8 - 09/30/2023 04:51 AM - nagachika (Tomoyuki Chikanaga)
https://github.com/ruby/ruby/commit/f34280ec6b684eeb21ef3336c7002e1a83dcfd2c


merge revision(s) 6b66b5fdedb2c9a9ee48e290d57ca7f8d55e01a2: [Backport #19902]

    [Bug #19902] Update the coderange regarding the changed region

    ---

     ext/-test-/string/set_len.c       | 10 ++++++++++

     string.c                          | 27 +++++++++++++++++++++++++++

     test/-ext-/string/test_set_len.rb | 29 +++++++++++++++++++++++++++++

     3 files changed, 66 insertions(+)

History

#1 - 09/26/2023 05:45 AM - nobu (Nobuyoshi Nakada)

https://github.com/ruby/ruby/pull/8511

#2 - 09/26/2023 06:35 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset git|6b66b5fdedb2c9a9ee48e290d57ca7f8d55e01a2.

[Bug #19902] Update the coderange regarding the changed region

#3 - 09/27/2023 02:38 PM - ima1zumi (Mari Imaizumi)

3.2にバックポートが必要そうです。

#4 - 09/28/2023 02:51 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 3.0: UNKNOWN, 3.1: UNKNOWN, 3.2: UNKNOWN to 3.0: UNKNOWN, 3.1: UNKNOWN, 3.2: REQUIRED

#5 - 09/30/2023 07:07 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 3.0: UNKNOWN, 3.1: UNKNOWN, 3.2: REQUIRED to 3.0: UNKNOWN, 3.1: UNKNOWN, 3.2: DONE

ruby_3_2 ddbab4f837460f070942e8127de9a9f1b9868fff merged revision(s) 6b66b5fdedb2c9a9ee48e290d57ca7f8d55e01a2.
